import 'dart:collection';
import 'dart:ui';

import 'package:bloc/bloc.dart';

class OffsetWithStroke {
  final Offset offset;
  final double stroke;
  final bool isEraser;
  final StrokeCap cap;

  OffsetWithStroke(this.offset, this.stroke, this.isEraser,
      {this.cap = StrokeCap.round});
}

class OffsetWithStrokeCubit extends Cubit<
    UnmodifiableListView<UnmodifiableListView<OffsetWithStroke?>>> {
  OffsetWithStrokeCubit()
      : super(UnmodifiableListView(UnmodifiableListView([])));

  void addToVersion(OffsetWithStroke? offsetWithStroke) {
    List<OffsetWithStroke?> newPoints = [...state.last, offsetWithStroke];
    var copy = state.toList();
    if (copy.isNotEmpty) copy.removeLast();
    emit(UnmodifiableListView([...copy, UnmodifiableListView(newPoints)]));
  }

  void add(List<OffsetWithStroke?> points) {
    emit(UnmodifiableListView([
      ...state,
      UnmodifiableListView([...state.last, ...points])
    ]));
  }

  void newVersion() {
    emit(UnmodifiableListView(
        [...state, state.isNotEmpty ? state.last : UnmodifiableListView([])]));
  }

  void emptyVersion() {
    emit(UnmodifiableListView([...state, UnmodifiableListView([])]));
  }

  void undo() {
    if (state.isNotEmpty) {
      var pointsWithoutLast = state.toList()..removeLast();
      emit(UnmodifiableListView(pointsWithoutLast));
    }
  }
}
