import 'package:bakalarka_frontend/pages/overview.dart';
import 'package:flutter/material.dart';
import 'package:localstorage/localstorage.dart';

void main() {
  runApp(MyApp());
}

class MyApp extends StatelessWidget {
  // This widget is the root of your application.
  @override
  Widget build(BuildContext context) {
    LocalStorage storage = LocalStorage('info');
    return MaterialApp(
      title: 'Annotator',
      theme: ThemeData(
        primarySwatch: Colors.amber,
        textTheme: TextTheme(
            bodyText2: TextStyle(fontSize: 25, color: Colors.black),
            bodyText1: TextStyle(fontSize: 30, color: Colors.black),
            button: TextStyle(
                fontSize: 25,
                color: Colors.black,
                fontWeight: FontWeight.w500)),
      ),
      home: FutureBuilder(
          future: storage.ready,
          builder: (context, snapshot) {
            if (snapshot.data == true) return Overview();
            return CircularProgressIndicator();
          }),
    );
  }
}
