import 'package:bakalarka_frontend/widgets/hyperparameters_dialog.dart';
import 'package:bakalarka_frontend/widgets/new_iteration_dialog.dart';
import 'package:flutter/material.dart';
import 'package:localstorage/localstorage.dart';

import 'iteration.dart';

class DatasetDetail extends StatelessWidget {
  final String _datasetName;
  final LocalStorage _storage = LocalStorage('info');

  DatasetDetail(this._datasetName);

  @override
  Widget build(BuildContext context) {
    Map<String, dynamic> datasets = _storage.getItem('datasets') == null
        ? Map()
        : _storage.getItem('datasets');
    Map<String, dynamic> iterations = _storage.getItem('iterations') == null
        ? Map()
        : _storage.getItem('iterations');
    return Scaffold(
      appBar: AppBar(
        title: Text(_datasetName),
      ),
      body: Center(
        child: Column(
          children: [
            SizedBox(
              height: 20,
            ),
            Text('This dataset contains ' +
                datasets[_datasetName]!['images'].length.toString() +
                ' images'),
            Text('Annotated: ' +
                (datasets[_datasetName]!.containsKey('annotated')
                    ? datasets[_datasetName]!['annotated'].length.toString()
                    : '0')),
            Text('Preannotated: ' +
                (datasets[_datasetName]!.containsKey('preannotated')
                    ? datasets[_datasetName]!['preannotated'].length.toString()
                    : '0')),
            TextButton(
              onPressed: () {
                if (iterations.containsKey(_datasetName)) {
                  Navigator.of(context).push(MaterialPageRoute(
                      builder: (context) => Iteration(_datasetName)));
                } else {
                  showDialog(
                    context: context,
                    builder: (context) => NewIterationDialog(_datasetName),
                    barrierDismissible: true,
                  );
                }
              },
              child: iterations.containsKey(_datasetName)
                  ? Text('Continue iteration')
                  : Text('Start next iteration'),
            ),
            TextButton(
              onPressed: () {
                showDialog(
                  context: context,
                  builder: (context) => HyperparametersDialog(_datasetName),
                  barrierDismissible: true,
                );
              },
              child: Text('Learning hyperparameters'),
            ),
          ],
        ),
      ),
    );
  }
}
