import 'package:bakalarka_frontend/pages/dataset_detail.dart';
import 'package:bakalarka_frontend/widgets/dataset_creation_dialog.dart';
import 'package:flutter/material.dart';
import 'package:localstorage/localstorage.dart';

class Overview extends StatelessWidget {
  final LocalStorage _storage = LocalStorage('info');

  @override
  Widget build(BuildContext context) {
    Map<String, dynamic> datasets = _storage.getItem('datasets') == null
        ? Map()
        : _storage.getItem('datasets');
    return Scaffold(
      body: FutureBuilder(
        future: _storage.ready,
        builder: (BuildContext context, snapshot) {
          if (snapshot.data == true) {
            return Padding(
              padding: const EdgeInsets.all(50.0),
              child: ListView(
                children: datasets.keys
                    .map((datasetName) => Card(
                          margin: EdgeInsets.all(10),
                          shape: RoundedRectangleBorder(
                              borderRadius: BorderRadius.circular(30)),
                          child: TextButton(
                              onPressed: () {
                                Navigator.of(context).push(MaterialPageRoute(
                                    builder: (context) =>
                                        DatasetDetail(datasetName)));
                              },
                              child: Padding(
                                padding: const EdgeInsets.all(20.0),
                                child: Text(datasetName,
                                    style: TextStyle(color: Colors.black)),
                              )),
                        ))
                    .toList(),
              ),
            );
          }
          return CircularProgressIndicator();
        },
      ),
      floatingActionButton: FloatingActionButton.extended(
        onPressed: () {
          showDialog(
              context: context,
              builder: (context) => DatasetCreationDialog(),
              barrierDismissible: true);
        },
        label: Text('Add new dataset'),
      ),
    );
  }
}
